#include <stdio.h>
#include <console.h> 

#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include <ctype.h>
#include <stdio.h>
// #include <malloc.h>

/* allocate vector of type float with indices that run from 0 to high */
float *fvec(int high); 
float *fvec(int high) {
	float *hold;
	hold=(float *)malloc((unsigned) (high+1)*sizeof(float));
	if (!hold) printf("Allocation error in fvec()\n");
	return hold;
}

/* free vector of type float with indices that run from 0 to high */
void freefvec(float *vecname) ;
void freefvec(float *vecname) {
   free((char*) (vecname));
}

/* allocate vector of type double with indices that run from 0 to high */
double *dvec(int high) ;
double *dvec(int high) {
	double *hold;
	hold=(double *)malloc((unsigned) (high+1)*sizeof(double));
	if (!hold) printf("Allocation error in dvec()\n");
	return hold;
}

/* free vector of type double with indices that run from 0 to high */
void freedvec(double *vecname) ;
void freedvec(double *vecname) {
   free((char*) (vecname));
}

/* allocate vector of type int with indices that run from 0 to high */
FILE **Fvec(int high) ;
FILE **Fvec(int high) {
	FILE **hold;
	hold=(FILE **)malloc((unsigned) (high+1)*sizeof(FILE *));
	if (!hold) printf("Allocation error in Fvec()\n");
	return hold;
}

/* free vector of type float int with indices that run from 0 to high */
void freeFvec(FILE **vecname) ;
void freeFvec(FILE **vecname) {
   free((char*) (vecname));
}

/* allocate vector of type int with indices that run from 0 to high */
int *ivec(int high) ;
int *ivec(int high) {
	int *hold;
	hold=(int *)malloc((unsigned) (high+1)*sizeof(int));
	if (!hold) printf("Allocation error in ivec()\n");
	return hold;
}

/* allocate vector of type int with indices that run from 0 to high */
char  *cvec(int high) ;
char  *cvec(int high) {
	char *hold;
	hold=(char *)malloc((unsigned) (high+1)*sizeof(char));
	if (!hold) printf("Allocation error in ivec()\n");
	return hold;
}

/* free vector of type float int with indices that run from 0 to high */
void freeivec(int *vecname) ;
void freeivec(int *vecname) {
   free((char*) (vecname));
}

/* allocate float matrix with indices that run 0->highrow, 0-> highcol */
float **fmat(int highrow, int highcol) ;
float **fmat(int highrow, int highcol) {
   int ktrack;
   float **hold;
   hold =(float **) malloc((unsigned) (highrow+1)*sizeof(float*));
   if (!hold) printf("Allocation Failure in fmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)   {
     hold[ktrack]=(float *) malloc((unsigned) (highcol+1)*sizeof(float));
     if (!hold[ktrack]) printf("Allocation Failure in fmat()\n");
   }
   return hold;
}

/* free float matrix with indices that run 0->highrow, 0-> highcol */
void freefmat(float **matname, int highrow, int highcol) ;
void freefmat(float **matname, int highrow, int highcol) {
   int ktrack;
   highcol=0;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}

 
/* free char matrix with indices that run 0->highrow, 0-> highcol */
void freecmat(char **matname, int highrow, int highcol) ;
void freecmat(char **matname, int highrow, int highcol) {
   int ktrack;
   highcol=0;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*)
(matname[ktrack]));
   free((char*) (matname));
}
 

/* allocate char matrix with indices that run 0->highrow, 0-> highcol */
char **cmat(int highrow, int highcol) ;
char **cmat(int highrow, int highcol) {
   int ktrack;
   char **hold;
   hold =(char **) malloc((unsigned) (highrow+1)*sizeof(char*));
   if (!hold) printf("Allocation Failure in cmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(char*) malloc((unsigned)
(highcol+1)*sizeof(char));
      if (!hold[ktrack]) printf("Allocation Failure in cmat()\n");
   }
   return hold;
}

/* allocate three-d integer matrix with indice that run 0->high,0->highrow,
            0-> highcol */
int ***threeimat(int high, int highrow, int highcol) ;
int ***threeimat(int high, int highrow, int highcol) {
   int ktrack,ktrack2;
   int ***hold3;
   hold3 =(int ***) malloc((unsigned) (high+1)*sizeof(int**));
   if (!hold3) printf("Allocation Failure in threeimat()\n");
   for(ktrack=0; ktrack<= high; ktrack++)
   {
      hold3[ktrack]=(int **) malloc((unsigned)
                     (highrow+1)*sizeof(int*));
      if (!hold3[ktrack]) printf("Allocation Failure in threeimat()\n");
      for(ktrack2=0;ktrack2<=highrow;ktrack2++)
      {
         hold3[ktrack][ktrack2] = (int *) malloc((unsigned)
                                   (highcol+1)*sizeof(int));
         if (!hold3[ktrack][ktrack2])
            printf("Allocation Failure in threeimat()\n");
      }
   }   
   return hold3;
}


/* allocate three-d double matrix with indice that run 0->high,0->highrow,
            0-> highcol */
double ***threedmat(int high, int highrow, int highcol) ;
double ***threedmat(int high, int highrow, int highcol) {
   int ktrack,ktrack2;
   double ***hold3;
   hold3 =(double ***) malloc((unsigned) (high+1)*sizeof(double**));
   if (!hold3) printf("Allocation Failure in threedmat()\n");
   for(ktrack=0; ktrack<= high; ktrack++)
   {
      hold3[ktrack]=(double **) malloc((unsigned)
                     (highrow+1)*sizeof(double*));
      if (!hold3[ktrack]) printf("Allocation Failure in threedmat()\n");
      for(ktrack2=0;ktrack2<=highrow;ktrack2++)
      {
         hold3[ktrack][ktrack2] = (double *) malloc((unsigned) 
                                   (highcol+1)*sizeof(double));
         if (!hold3[ktrack][ktrack2]) 
            printf("Allocation Failure in threedmat()\n");
      }
   }
   return hold3;
}
 
 
/* allocate double matrix with indices that run 0->highrow, 0-> highcol */
double **dmat(int highrow, int highcol) ;
double **dmat(int highrow, int highcol) {
   int ktrack;
   double **hold;
   hold =(double **) malloc((unsigned) (highrow+1)*sizeof(double*));
   if (!hold) printf("Allocation Failure in dmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(double *) malloc((unsigned) (highcol+1)*sizeof(double));
      if (!hold[ktrack]) printf("Allocation Failure in dmat()\n");
   }
   return hold;
}

/* free double matrix with indices that run 0->highrow, 0-> highcol */
void freedmat(double **matname, int highrow, int highcol) ;
void freedmat(double **matname, int highrow, int highcol) {
   int ktrack;
   highcol=0;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}

 
/* free 3d integer matrix with indices 0->high, 0->highrow, 0-> highcol */
void freethreeimat(int ***matname, int high, int highrow, int highcol) ;
void freethreeimat(int ***matname, int high, int highrow, int highcol) {
   int ktrack,ktrack2;
   highcol=0;
   for(ktrack=high;ktrack>=0;ktrack--)
   {
      for(ktrack2=highrow;ktrack2>=0;ktrack2--) free((char*)
         (matname[ktrack][ktrack2]));
      free((char*) (matname[ktrack]));
   }
   free((char*) (matname));
}


/* free 3d double matrix with indices 0->high, 0->highrow, 0-> highcol */
void freethreedmat(double ***matname, int high, int highrow,  int highcol) ;
void freethreedmat(double ***matname, int high, int highrow,  int highcol) {
   int ktrack,ktrack2;
   highcol=0;
   for(ktrack=high;ktrack>=0;ktrack--) 
   {
      for(ktrack2=highrow;ktrack2>=0;ktrack2--) free((char*) 
         (matname[ktrack][ktrack2]));
      free((char*) (matname[ktrack]));
   }
   free((char*) (matname));
}  

/* allocate int matrix with indices that run 0->highrow, 0-> highcol */
int **imat(int highrow, int highcol) ;
int **imat(int highrow, int highcol) {
   int ktrack;
   int **hold;
   hold =(int **) malloc((unsigned) (highrow+1)*sizeof(int*));
   if (!hold) printf("Allocation Failure in imat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(int *) malloc((unsigned) (highcol+1)*sizeof(int));
      if (!hold[ktrack]) printf("Allocation Failure in imat()\n");
   }
   return hold;
}

/* free int matrix with indices that run 0->highrow, 0-> highcol */
void freeimat(int **matname, int highrow, int highcol) ;
void freeimat(int **matname, int highrow, int highcol) {
   int ktrack;
   highcol=0;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}
