void iheader(FILE *fp, char *words,char *words2,int deflt, int val){
  	fprintf(fp,"\t%s (%s): %d (%d)\n",   words, words2,deflt, val);
}

void dheader(FILE *fp, char *words,char *words2,double deflt, double val){
  	fprintf(fp,"\t%s (%s): %lf (%lf)\n",   words, words2,deflt, val);
}

void prt1(FILE *fp,double value){
	
	if ((int) value == value) fprintf(stderr,"%6.0lf ",value);
	else if (value<1.0) fprintf(stderr,"%0.4lf ",value);
	else fprintf(stderr,"%6.2lf ",value);
}

void CommandInit(){
	file_default = "infile";

	globs.cycles = cycle_default=10000; 
	globs.skip = skip_default=100; 
	globs.amove = amove_default=0.1; 
	globs.imove = imove_default=0.5; 
	globs.fmove = fmove_default=0.1; 
	globs.seed = seed_default = 9873241;
	globs.loudness = loudness_default = 0;
	globs.cats = cats_default = 0;
	globs.cline = cline_default = 0;
	globs.gamma = gamma_default = 1;
	globs.test = test_default = 1;
	globs.varfreqs = varfreqs_default = 0;
	globs.file = open_input(file_default);
}

void DoIntro(){
	fprintf(stderr,"Format: branch [skip] [cycles] [amove] [imove] [seed] [loudness]\n");
	fprintf(stderr,"Variables read in order shown; subsequent variables are optional.\n\n");
	fprintf(stderr,"Variable: Default value (chosen value): \n");
}

void ListVariables(FILE *fp,char next_file[MAXNAME]){

	time_t systime;
     systime = time(NULL);         
  //   puts(ctime(&systime));
    fprintf(fp,"\nSaturation Mutagenesis run %d, %s\n",globs.seed, ctime(&systime), time(NULL));
    fprintf(fp,"\tInput file:\t%s\t\n\n",next_file);
	iheader(fp,"Chain Length", "cycles of random # generation",  cycle_default, globs.cycles);
	iheader(fp,"Sampling Rate", "number of rate divisions",  skip_default, globs.skip);

	iheader(fp,"Gamma", "on/off? [1/0]",  gamma_default, globs.gamma);
	iheader(fp,"Categories", "Number [only if gamma off]",  cats_default, globs.cats);
	iheader(fp,"Do Frequencies", "Frequencies of categories? [even if off]",  varfreqs_default, globs.varfreqs);
	
	dheader(fp,"alpha movement","range for Markov Chain",  amove_default, globs.amove);
	dheader(fp,"rate movement","range for Markov Chain",  imove_default, globs.imove);
	dheader(fp,"frequency movement","range for Markov Chain",  fmove_default, globs.fmove);

	iheader(fp,"Test", "if test run, don't record", test_default, globs.test);
	iheader(fp,"Seed", "for random number generator", seed_default, globs.seed);
	iheader(fp,"Noise level", "debugging", loudness_default, globs.loudness);
	fprintf(fp,"\n\n");
}

void DoCommandLine(int argc, char *argv[]){
	int cr;
	cr=0; 

	globs.skip= Get_iCommand(&cr,argv,argc,  globs.skip );
	globs.cycles= Get_iCommand(&cr,argv,argc, globs.cycles  );
	globs.seed= Get_iCommand(&cr,argv,argc, globs.seed  );
	globs.test= Get_iCommand(&cr,argv,argc, globs.test  );
}

void blurb(char *name, int numb, double real);
void blurb(char *name, int numb, double real){
	fprintf(stderr, "Command read from file: %15s\t", name);
	if(numb != -1) fprintf(stderr, "%d\t", numb);
	if(real != -1) fprintf(stderr, "%lf\t", real);
	fprintf(stderr, "\n");
}

void DoCommandFile(char next_file[MAXNAME]);
void DoCommandFile(char next_file[MAXNAME]){
	int cr;  
	char c;
	char *commands="commands";
	FILE *COMM;
 	char line[500];
 	char name[20];
 	double real;
 	int number;
 	cr=0;


	fprintf(stderr, "Reading Commands.\n", name, number, real);
	COMM=open_input(commands);
	if ( COMM != NULL )
	{
		while ( (fscanf( COMM, "%s",name)) != EOF ){
			number=-1; real=-1;
			if (strcmp(name,"skip")==0) { fscanf(COMM,"%d",&number); globs.skip=number; blurb(name,number,real); }
			if (strcmp(name,"cycles")==0) { fscanf(COMM,"%d",&number); globs.cycles=number;  blurb(name,number,real);}
			if (strcmp(name,"loudness")==0) { fscanf(COMM,"%d",&number); globs.loudness=number;  blurb(name,number,real);}
			if (strcmp(name,"seed")==0) { fscanf(COMM,"%d",&number); globs.seed=number; blurb(name,number,real); }
			if (strcmp(name,"cats")==0) { fscanf(COMM,"%d",&number); globs.cats=number; }
			if (strcmp(name,"gamma")==0) { fscanf(COMM,"%d",&number); globs.gamma=number; }
			if (strcmp(name,"varfreqs")==0) { fscanf(COMM,"%d",&number); globs.varfreqs=number; }
			if (strcmp(name,"file")==0) { globs.file=GetFileName(COMM, next_file); }
			
			if (strcmp(name,"test")==0) { fscanf(COMM,"%d",&number); globs.test=number; }
			if (strcmp(name,"amove")==0) { fscanf(COMM,"%lf",&real); globs.amove=real; blurb(name,number,real); }
			if (strcmp(name,"imove")==0) { fscanf(COMM,"%lf",&real); globs.imove=real; blurb(name,number,real); }
			if (strcmp(name,"fmove")==0) { fscanf(COMM,"%lf",&real); globs.fmove=real; }
		}
		fclose( COMM );
	} FPN;
}


void DoCommands3(FILE *fp, int argc, char *argv[]){
	int cr;
	char next_file[40];
	FILE *REC;
	cr=0; 
	
	CommandInit();
	DoIntro();
	DoCommandFile(next_file);
	if(globs.cline) {
		// from A. Rambaut via PAML to do dialog box for command line parameterson mac.
		#ifdef __MWERKS__
			argc=ccommand(&argv);
		#endif
		DoCommandLine(argc,argv);
	}
	if(globs.test == 1) REC=fp; else REC=stderr;
	ListVariables(REC,next_file); 
}

