#define STATES 20
#define MAXSEQ 100
#define EXPNUM 1000000
#define EXPFACTOR 1000.0

// GLOBAL VARIABLES
double MJ_matrix[STATES][STATES];
double Ran_matrix[STATES][STATES];
double Energy_matrix[STATES][STATES];
char *Aacode[26]={"ALA","ASX","CYS","ASP","GLU","PHE",
	    "GLY","HIS","ILE","JJJ","LYS","LEU",
	    "MET","ASN","OOO","PRO","GLN","ARG",
	    "SER","THR","UUU","VAL","TRP","XXX",
	    "TYR","GLX"};
char Aminos[STATES]={'A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V'};
char *Aminos2[STATES]={"A","R","N","D","C","Q","E","G","H","I","L","K","M","F","P","S","T","W","Y","V"};
double ExpVector[EXPNUM];


// function prototypes
CreateMJMatrix();
printmatrix(FILE *fp, double matrix[STATES][STATES]);

// Functions

FillExpVec();
FillExpVec(){
	int i;
	for (i=0;i<EXPNUM;i++){
		ExpVector[i]=exp((double) i / EXPFACTOR);
	}
}

double GetExp(double number);
double GetExp(double number){
	int i,j;
	double ratio, result;
	
	i=(int) (number/EXPFACTOR);
	j=i+1;
	ratio=(number-(i/EXPFACTOR))/(j/EXPFACTOR-i/EXPFACTOR);
	result=(ExpVector[j]-ExpVector[i])*(ratio)+ExpVector[i];
	//fprintf(stderr,"%lf %lf %lf %d %d; %lf %lf; %lf %lf\n",number, ratio, result, i,j,ExpVector[i],ExpVector[j],(double)i*EXPFACTOR,(double)j*EXPFACTOR);
	return(result);
}


CreateRanMatrix();
CreateRanMatrix(){
// Randomly enter a matrix, similar to the MJ. Copy to Inverse.
int i,j;
	if (0){ for(i=0;i<STATES;i++) for (j=i;j<STATES;j++){ Ran_matrix[i][j]= - FRND*7.4;Ran_matrix[j][i]=Ran_matrix[i][j];}}
	else {
		for(i=0;i<STATES;i++) for (j=i;j<STATES;j++){
			Ran_matrix[i][j]= (sqrt((double) SQR(i-j)) - 19.1) * 7.4/19.1;
//			Ran_matrix[i][j]= ((SQR(i-j)) - 19.1)*7.4/19.1;
			Ran_matrix[j][i]=Ran_matrix[i][j];
		}
	}
}

EnergyMatrix(FILE *fp, double InMatrix[STATES][STATES]);
EnergyMatrix(FILE *fp, double InMatrix[STATES][STATES]){
// Copy an input amino acid matrix to the energy matrix.
int i,j;
	for(i=0;i<STATES;i++) for (j=0;j<STATES;j++){ Energy_matrix[i][j]= InMatrix[i][j];}
}

CreateMJMatrix(){
// manually enter Miyazawa Jernigan MJ__matrix. Copy to Inverse.
int i,j;

	MJ_matrix[0][0]=-5.44;
	MJ_matrix[0][1]=-4.99;
	MJ_matrix[0][2]=-5.80;
	MJ_matrix[0][3]=-5.50;
	MJ_matrix[0][4]=-5.83;
	MJ_matrix[0][5]=-4.96;
	MJ_matrix[0][6]=-4.95;
	MJ_matrix[0][7]=-4.16;
	MJ_matrix[0][8]=-3.57;
	MJ_matrix[0][9]=-3.16;
	MJ_matrix[0][10]=-3.31;
	MJ_matrix[0][11]=-2.86;
	MJ_matrix[0][12]=-2.59;
	MJ_matrix[0][13]=-2.85;
	MJ_matrix[0][14]=-2.41;
	MJ_matrix[0][15]=-2.27;
	MJ_matrix[0][16]=-3.60;
	MJ_matrix[0][17]=-2.57;
	MJ_matrix[0][18]=-1.95;
	MJ_matrix[0][19]=-3.07;


	MJ_matrix[1][1]=-5.46;
	MJ_matrix[1][2]=-6.56;
	MJ_matrix[1][3]=-6.02;
	MJ_matrix[1][4]=-6.41;
	MJ_matrix[1][5]=-5.32;
	MJ_matrix[1][6]=-5.55;
	MJ_matrix[1][7]=-4.91;
	MJ_matrix[1][8]=-3.94;
	MJ_matrix[1][9]=-3.39;
	MJ_matrix[1][10]=-3.51;
	MJ_matrix[1][11]=-3.03;
	MJ_matrix[1][12]=-2.95;
	MJ_matrix[1][13]=-3.30;
	MJ_matrix[1][14]=-2.57;
	MJ_matrix[1][15]=-2.89;
	MJ_matrix[1][16]=-3.98;
	MJ_matrix[1][17]=-3.12;
	MJ_matrix[1][18]=-2.48;
	MJ_matrix[1][19]=-3.45;

	MJ_matrix[2][2]=-7.26;
	MJ_matrix[2][3]=-6.84;
	MJ_matrix[2][4]=-7.28;
	MJ_matrix[2][5]=-6.29;
	MJ_matrix[2][6]=-6.16;
	MJ_matrix[2][7]=-5.66;
	MJ_matrix[2][8]=-4.81;
	MJ_matrix[2][9]=-4.13;
	MJ_matrix[2][10]=-4.28;
	MJ_matrix[2][11]=-4.02;
	MJ_matrix[2][12]=-3.75;
	MJ_matrix[2][13]=-4.10;
	MJ_matrix[2][14]=-3.48;
	MJ_matrix[2][15]=-3.56;
	MJ_matrix[2][16]=-4.77;
	MJ_matrix[2][17]=-3.98;
	MJ_matrix[2][18]=-3.36;
	MJ_matrix[2][19]=-4.25;


	MJ_matrix[3][3]=-6.54;
	MJ_matrix[3][4]=-7.04;
	MJ_matrix[3][5]=-6.05;
	MJ_matrix[3][6]=-5.78;
	MJ_matrix[3][7]=-5.25;
	MJ_matrix[3][8]=-4.58;
	MJ_matrix[3][9]=-3.78;
	MJ_matrix[3][10]=-4.03;
	MJ_matrix[3][11]=-3.52;
	MJ_matrix[3][12]=-3.24;
	MJ_matrix[3][13]=-3.67;
	MJ_matrix[3][14]=-3.17;
	MJ_matrix[3][15]=-3.27;
	MJ_matrix[3][16]=-4.14;
	MJ_matrix[3][17]=-3.63;
	MJ_matrix[3][18]=-3.01;
	MJ_matrix[3][19]=-3.76;

	MJ_matrix[4][4]=-7.37;
	MJ_matrix[4][5]=-6.48;
	MJ_matrix[4][6]=-6.14;
	MJ_matrix[4][7]=-5.67;
	MJ_matrix[4][8]=-4.91;
	MJ_matrix[4][9]=-4.16;
	MJ_matrix[4][10]=-4.34;
	MJ_matrix[4][11]=-3.92;
	MJ_matrix[4][12]=-3.74;
	MJ_matrix[4][13]=-4.04;
	MJ_matrix[4][14]=-3.40;
	MJ_matrix[4][15]=-3.59;
	MJ_matrix[4][16]=-4.54;
	MJ_matrix[4][17]=-4.03;
	MJ_matrix[4][18]=-3.37;
	MJ_matrix[4][19]=-4.20;

	MJ_matrix[5][5]=-5.52;
	MJ_matrix[5][6]=-5.18;
	MJ_matrix[5][7]=-4.62;
	MJ_matrix[5][8]=-4.04;
	MJ_matrix[5][9]=-3.38;
	MJ_matrix[5][10]=-3.46;
	MJ_matrix[5][11]=-3.05;
	MJ_matrix[5][12]=-2.83;
	MJ_matrix[5][13]=-3.07;
	MJ_matrix[5][14]=-2.48;
	MJ_matrix[5][15]=-2.67;
	MJ_matrix[5][16]=-3.58;
	MJ_matrix[5][17]=-3.07;
	MJ_matrix[5][18]=-2.49;
	MJ_matrix[5][19]=-3.32;

	MJ_matrix[6][6]=-5.06;
	MJ_matrix[6][7]=-4.66;
	MJ_matrix[6][8]=-3.82;
	MJ_matrix[6][9]=-3.42;
	MJ_matrix[6][10]=-3.22;
	MJ_matrix[6][11]=-2.99;
	MJ_matrix[6][12]=-3.07;
	MJ_matrix[6][13]=-3.11;
	MJ_matrix[6][14]=-2.84;
	MJ_matrix[6][15]=-3.99;
	MJ_matrix[6][16]=-3.98;
	MJ_matrix[6][17]=-3.41;
	MJ_matrix[6][18]=-2.69;
	MJ_matrix[6][19]=-3.73;

	MJ_matrix[7][7]=-4.17;
	MJ_matrix[7][8]=-3.36;
	MJ_matrix[7][9]=-3.01;
	MJ_matrix[7][10]=-3.01;
	MJ_matrix[7][11]=-2.78;
	MJ_matrix[7][12]=-2.76;
	MJ_matrix[7][13]=-2.97;
	MJ_matrix[7][14]=-2.76;
	MJ_matrix[7][15]=-2.79;
	MJ_matrix[7][16]=-3.52;
	MJ_matrix[7][17]=-3.16;
	MJ_matrix[7][18]=-2.60;
	MJ_matrix[7][19]=-3.19;

	MJ_matrix[8][8]=-2.72;
	MJ_matrix[8][9]=-2.31;
	MJ_matrix[8][10]=-2.32;
	MJ_matrix[8][11]=-2.01;
	MJ_matrix[8][12]=-1.84;
	MJ_matrix[8][13]=-1.89;
	MJ_matrix[8][14]=-1.70;
	MJ_matrix[8][15]=-1.51;
	MJ_matrix[8][16]=-2.41;
	MJ_matrix[8][17]=-1.83;
	MJ_matrix[8][18]=-1.31;
	MJ_matrix[8][19]=-2.03;

	MJ_matrix[9][9]=-2.24;
	MJ_matrix[9][10]=-2.08;
	MJ_matrix[9][11]=-1.82;
	MJ_matrix[9][12]=-1.74;
	MJ_matrix[9][13]=-1.66;
	MJ_matrix[9][14]=-1.59;
	MJ_matrix[9][15]=-1.22;
	MJ_matrix[9][16]=-2.15;
	MJ_matrix[9][17]=-1.72;
	MJ_matrix[9][18]=-1.15;
	MJ_matrix[9][19]=-1.87;

	MJ_matrix[10][10]=-2.12;
	MJ_matrix[10][11]=-1.96;
	MJ_matrix[10][12]=-1.88;
	MJ_matrix[10][13]=-1.90;
	MJ_matrix[10][14]=-1.80;
	MJ_matrix[10][15]=-1.74;
	MJ_matrix[10][16]=-2.42;
	MJ_matrix[10][17]=-1.90;
	MJ_matrix[10][18]=-1.31;
	MJ_matrix[10][19]=-1.90;


	MJ_matrix[11][11]=-1.67;
	MJ_matrix[11][12]=-1.58;
	MJ_matrix[11][13]=-1.49;
	MJ_matrix[11][14]=-1.63;
	MJ_matrix[11][15]=-1.48;
	MJ_matrix[11][16]=-2.11;
	MJ_matrix[11][17]=-1.62;
	MJ_matrix[11][18]=-1.05;
	MJ_matrix[11][19]=-1.57;


	MJ_matrix[12][12]=-1.68;
	MJ_matrix[12][13]=-1.71;
	MJ_matrix[12][14]=-1.68;
	MJ_matrix[12][15]=-1.51;
	MJ_matrix[12][16]=-2.08;
	MJ_matrix[12][17]=-1.64;
	MJ_matrix[12][18]=-1.21;
	MJ_matrix[12][19]=-1.53;

	MJ_matrix[13][13]=-1.54;
	MJ_matrix[13][14]=-1.46;
	MJ_matrix[13][15]=-1.42;
	MJ_matrix[13][16]=-1.98;
	MJ_matrix[13][17]=-1.80;
	MJ_matrix[13][18]=-1.29;
	MJ_matrix[13][19]=-1.73;


	MJ_matrix[14][14]=-1.21;
	MJ_matrix[14][15]=-1.02;
	MJ_matrix[14][16]=-2.32;
	MJ_matrix[14][17]=-2.29;
	MJ_matrix[14][18]=-1.68;
	MJ_matrix[14][19]=-1.33;


	MJ_matrix[15][15]=-0.91;
	MJ_matrix[15][16]=-2.15;
	MJ_matrix[15][17]=-2.27;
	MJ_matrix[15][18]=-1.80;
	MJ_matrix[15][19]=-1.26;


	MJ_matrix[16][16]=-3.05;
	MJ_matrix[16][17]=-2.16;
	MJ_matrix[16][18]=-1.35;
	MJ_matrix[16][19]=-2.25;

	MJ_matrix[17][17]=-1.55;
	MJ_matrix[17][18]=-0.59;
	MJ_matrix[17][19]=-1.70;

	MJ_matrix[18][18]=-0.12;
	MJ_matrix[18][19]=-0.97;

	MJ_matrix[19][19]=-1.75;
	
	for (i=0;i<STATES;i++)  for (j=0;j<STATES;j++) 
		if(i>j)  MJ_matrix[i][j]=MJ_matrix[j][i];
	
}

printmatrix(FILE *fp, double matrix[STATES][STATES]){
// print 20x20 amino acid distance/exchange matrix
	int i,j;	

	for (i=0;i<STATES;i++) fprintf(fp,"%6c",Aminos[i]); fprintf (fp, "\n");
	for (i=0;i<STATES;i++) { for (j=0;j<STATES;j++) {
		fprintf(fp,"%6.2lf",matrix[i][j]);
} fprintf (fp, "\n"); }}

fpdvec(FILE *fp, double vector[],int length,int marker);
fpdvec(FILE *fp, double vector[],int length,int marker){
// print double vector to file
	int i,j;	
	
	fprintf (fp, "%d ",marker);
	for (i=0;i<length;i++) { fprintf(fp,"%6.2lf",vector[i]);} fprintf (fp, "\n"); 
}

int rndm(int a, int b);
int rndm(int a, int b){
// This is Jerry's rndm function
	clock_t t;
	int w;
	int temp;
	t=clock();  // get the seed from clock
	w=abs(((rand()+(int)t)%(b-a))+a);
	return w;
}

int *CreateSeq(int sequence[], int length);
int *CreateSeq(int sequence[], int length){
// Create a random sequence
	int i;	
	for (i=0;i<length;i++) sequence[i]=rndm(0,STATES);
}

int printseq(FILE *fp,int sequence[], int length);
int printseq(FILE *fp,int sequence[], int length){
// print a sequence
	int i;	
	for (i=0;i<length;i++) fprintf(fp,"%c",Aminos[sequence[i]]); fprintf (fp, "\n");
}

int copyseq(int sequenceFrom[],int sequenceTo[],int length);
int copyseq(int sequenceFrom[],int sequenceTo[], int length){
// copy first sequence to second 
	int i;	
	for (i=0;i<length;i++) sequenceTo[i]=sequenceFrom[i];
}

int randomizeseq(int seq[],int length);
int randomizeseq(int seq[],int length){
// randomly swap spots in sequence
	int i,site1,site2,temp;	
	if (0) { fprintf(stderr, "1; "); printseq(stderr,seq,length); }
	for (i=0;i<100;i++) {site1=FRND*length;site2=FRND*length;temp=seq[site1];seq[site1]=seq[site2];seq[site2]=temp;}
	if (0) { fprintf(stderr, "2: "); printseq(stderr,seq,length); }
}

double similarity(int seq1[],int seq2[], int length);
double similarity(int seq1[],int seq2[], int length){
// copy first sequence to second 
	int i,sim=0;	
	for (i=0;i<length;i++) if(seq1[i]==seq2[i]) sim++;
	return((double) sim);
}

double mutate(int sequence[],int mutseq[],double rate, int length);
double mutate(int sequence[],int mutseq[],double rate, int length){
// return time to first mutation, given rate, and mutate the sequence
	int i; int site=rndm(0,length);
	double time=-log(rand()/rate)/rate;
	
	copyseq(sequence,mutseq,length);
	mutseq[site]=rndm(0,STATES);
	// fprintf(stderr,"Time %lf, site %d. ",time,site); printseq(stderr,mutseq,length);
	return time;
}

double mutate2(int sequence[],int seq2[],int mutseq[],double rate, int length, int *whichseq);
double mutate2(int sequence[],int seq2[],int mutseq[],double rate, int length, int *whichseq){
// return time to first mutation, given rate, and mutate the sequence
	int i; int site=rndm(0,length);
	double time,rannum=FRND;
	
	time=-log(rannum*rate)*rate;
	*whichseq=(int) (rndm(0,2));
	// fprintf (stderr,"%d::: ",*whichseq);
	if (*whichseq==0) copyseq(sequence,mutseq,length);
	else copyseq(seq2,mutseq,length);
	mutseq[site]=rndm(0,STATES);
	// fprintf(stderr,"Time %lf, site %d. ",time,site); printseq(stderr,mutseq,length);
	return time;
}

int printseq2(FILE *fp,int sequence[], int length);
int printseq2(FILE *fp,int sequence[], int length){
// print a sequence
	int i;	
	for (i=0;i<length;i++) fprintf(fp,"%3d",sequence[i]); fprintf (fp, "\n");
}

