#include <stdio.h>
#include <console.h> 

#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include <ctype.h>
/* CAUTION: This is a clipped version for use with some eigen stuff.  */

#define NR_END 1
#define FREE_ARG char*

/* Numerical Recipes standard error handler */
void nrerror(char error_text[]);
void nrerror(char error_text[]) {
        fprintf(stderr,"Numerical Recipes run-time error...\n");
        fprintf(stderr,"%s\n",error_text);
        fprintf(stderr,"...now exiting to system...\n");
        exit(1);
}

int *ivector(long nl, long nh);
int *ivector(long nl, long nh)
/* allocate an int vector with subscript range v[nl..nh] */
{
        int *v;

        v=(int *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(int)));
        if (!v) nrerror("allocation failure in ivector()");
        return v-nl+NR_END;
}

void free_ivector(int *v, long nl, long nh);
void free_ivector(int *v, long nl, long nh)
/* free an int vector allocated with ivector() */
{
  nh=0;
  free((FREE_ARG) (v+nl-NR_END));
}

